diff --git a/app/Support/Authorization/AuthorizationUserTrait.php b/app/Support/Authorization/AuthorizationUserTrait.php
index 23839d8..3ce1a9b 100644
--- a/app/Support/Authorization/AuthorizationUserTrait.php
+++ b/app/Support/Authorization/AuthorizationUserTrait.php
@@ -27,15 +27,31 @@ trait AuthorizationUserTrait
     /**
      * Check if user can perform some action.
      * @param $permission
+     * @param bool $allRequired
      * @return bool
      */
-    public function hasPermission($permission)
+    public function hasPermission($permission, $allRequired = true)
     {
         $permission = (array) $permission;
-        $permissions = $this->role->cachedPermissions()->pluck('name')->toArray();
 
-        foreach ($permission as $perm) {
-            if (! in_array($perm, $permissions, true)) {
+        return $allRequired
+            ? $this->hasAllPermissions($permission)
+            : $this->hasAtLeastOnePermission($permission);
+    }
+
+    /**
+     * Check if user has all provided permissions
+     * (translates to AND logic between permissions).
+     *
+     * @param array $permissions
+     * @return bool
+     */
+    private function hasAllPermissions(array $permissions)
+    {
+        $availablePermissions = $this->role->cachedPermissions()->pluck('name')->toArray();
+
+        foreach ($permissions as $perm) {
+            if (! in_array($perm, $availablePermissions, true)) {
                 return false;
             }
         }
@@ -44,6 +60,26 @@ trait AuthorizationUserTrait
     }
 
     /**
+     * Check if user has at least one of provided permissions
+     * (translates to OR logic between permissions).
+     *
+     * @param array $permissions
+     * @return bool
+     */
+    private function hasAtLeastOnePermission(array $permissions)
+    {
+        $availablePermissions = $this->role->cachedPermissions()->pluck('name')->toArray();
+
+        foreach ($permissions as $perm) {
+            if (in_array($perm, $availablePermissions, true)) {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    /**
      * Set user's role.
      * @param Role $role
      * @return mixed
diff --git a/app/Support/DataArraySerializer.php b/app/Support/DataArraySerializer.php
new file mode 100644
index 0000000..86bf70c
--- /dev/null
+++ b/app/Support/DataArraySerializer.php
@@ -0,0 +1,100 @@
+<?php
+
+namespace Portal\Support;
+
+use League\Fractal\Pagination\PaginatorInterface;
+
+class DataArraySerializer extends \League\Fractal\Serializer\DataArraySerializer
+{
+    /**
+     * {@inheritdoc}
+     */
+    public function item($resourceKey, array $data)
+    {
+        return $data;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function collection($resourceKey, array $data)
+    {
+        if ($resourceKey) {
+            return [$resourceKey => $data];
+        }
+
+        return $data;
+    }
+
+    /**
+     * Format pagination data according to Illiminate defined format.
+     *
+     * @param PaginatorInterface $paginator
+     * @return array
+     */
+    public function paginator(PaginatorInterface $paginator)
+    {
+        $currentPage = $paginator->getCurrentPage();
+        $lastPage = $paginator->getLastPage();
+
+        $nextPage = $lastPage > $currentPage
+            ? $paginator->getUrl($currentPage + 1)
+            : null;
+
+        $prevPage = $currentPage > 1
+            ? $paginator->getUrl($currentPage - 1)
+            : null;
+
+        $data = [
+            'total' => $paginator->getTotal(),
+            'per_page' => $paginator->getPerPage(),
+            'current_page' => $currentPage,
+            'last_page' => $paginator->getLastPage(),
+            'next_page_url' => $nextPage,
+            'prev_page_url' => $prevPage,
+            'from' => $this->firstItem($paginator),
+            'to' => $this->lastItem($paginator),
+        ];
+
+        return ['meta' => $data];
+    }
+
+    /**
+     * Get the number of the first item in the slice.
+     *
+     * @param PaginatorInterface $paginator
+     * @return int
+     */
+    private function firstItem(PaginatorInterface $paginator)
+    {
+        if ($paginator->getCount() === 0) {
+            return;
+        }
+
+        return ($paginator->getCurrentPage() - 1) * $paginator->getPerPage() + 1;
+    }
+
+    /**
+     * Get the number of the last item in the slice.
+     *
+     * @param PaginatorInterface $paginator
+     * @return int
+     */
+    private function lastItem(PaginatorInterface $paginator)
+    {
+        if ($paginator->getCount() === 0) {
+            return;
+        }
+
+        return $this->firstItem($paginator) + $paginator->getCount() - 1;
+    }
+
+    public function meta(array $meta)
+    {
+        if (empty($meta)) {
+            return [];
+        }
+
+        return $meta;
+    }
+}
diff --git a/app/Transformers/ActivityTransformer.php b/app/Transformers/ActivityTransformer.php
new file mode 100644
index 0000000..4882b16
--- /dev/null
+++ b/app/Transformers/ActivityTransformer.php
@@ -0,0 +1,36 @@
+<?php
+
+namespace Portal\Transformers;
+
+use League\Fractal\TransformerAbstract;
+use Portal\Repositories\User\UserRepository;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\User;
+
+class ActivityTransformer extends TransformerAbstract
+{
+    protected $availableIncludes = ['user'];
+
+    public function transform(Activity $activity)
+    {
+        $agent = app('agent');
+        $agent->setUserAgent($activity->user_agent);
+
+        return [
+            'id' => (int) $activity->id,
+            'user_id' => (int) $activity->user_id,
+            'ip_address' => $activity->ip_address,
+            'user_agent' => $activity->user_agent,
+            'browser' => $agent->browser(),
+            'platform' => $agent->platform(),
+            'device' => $agent->device(),
+            'description' => $activity->description,
+            'created_at' => (string) $activity->created_at
+        ];
+    }
+
+    public function includeUser(Activity $activity)
+    {
+        return $this->item($activity->user, new UserTransformer);
+    }
+}
diff --git a/app/Transformers/CountryTransformer.php b/app/Transformers/CountryTransformer.php
new file mode 100644
index 0000000..526b7e0
--- /dev/null
+++ b/app/Transformers/CountryTransformer.php
@@ -0,0 +1,32 @@
+<?php
+
+namespace Portal\Transformers;
+
+use League\Fractal\TransformerAbstract;
+use Portal\Country;
+
+class CountryTransformer extends TransformerAbstract
+{
+    public function transform(Country $country)
+    {
+        return [
+            'id' => (int) $country->id,
+            'name' => $country->name,
+            'full_name' => $country->full_name,
+            'capital' => $country->capital,
+            'citizenship' => $country->citizenship,
+            'country_code' => (int) $country->country_code,
+            'currency' => $country->currency,
+            'currency_code' => $country->currency_code,
+            'currency_sub_unit' => $country->currency_sub_unit,
+            'currency_symbol' => $country->currency_symbol,
+            'iso_3166_2' => $country->iso_3166_2,
+            'iso_3166_3' => $country->iso_3166_3,
+            'region_code' => (int) $country->region_code,
+            'sub_region_code' => (int) $country->sub_region_code,
+            'eea' => (boolean) $country->eea,
+            'calling_code' => (int) $country->calling_code,
+            'flag' => $country->flag ? url("flags/{$country->flag}") : null
+        ];
+    }
+}
diff --git a/app/Transformers/PermissionTransformer.php b/app/Transformers/PermissionTransformer.php
new file mode 100644
index 0000000..2fe91f5
--- /dev/null
+++ b/app/Transformers/PermissionTransformer.php
@@ -0,0 +1,22 @@
+<?php
+
+namespace Portal\Transformers;
+
+use League\Fractal\TransformerAbstract;
+use Portal\Permission;
+
+class PermissionTransformer extends TransformerAbstract
+{
+    public function transform(Permission $permission)
+    {
+        return [
+            'id' => (int) $permission->id,
+            'name' => $permission->name,
+            'display_name' => $permission->display_name,
+            'description' => $permission->description,
+            'removable' => (boolean) $permission->removable,
+            'updated_at' => (string) $permission->updated_at,
+            'created_at' => (string) $permission->created_at
+        ];
+    }
+}
diff --git a/app/Transformers/RoleTransformer.php b/app/Transformers/RoleTransformer.php
new file mode 100644
index 0000000..4c19bcf
--- /dev/null
+++ b/app/Transformers/RoleTransformer.php
@@ -0,0 +1,33 @@
+<?php
+
+namespace Portal\Transformers;
+
+use League\Fractal\TransformerAbstract;
+use Portal\Role;
+
+class RoleTransformer extends TransformerAbstract
+{
+    protected $availableIncludes = ['permissions'];
+
+    public function transform(Role $role)
+    {
+        return [
+            'id' => (int) $role->id,
+            'name' => $role->name,
+            'display_name' => $role->display_name,
+            'description' => $role->description,
+            'removable' => (boolean) $role->removable,
+            'users_count' => is_null($role->users_count) ? null : (int) $role->users_count,
+            'updated_at' => (string) $role->updated_at,
+            'created_at' => (string) $role->created_at
+        ];
+    }
+
+    public function includePermissions(Role $role)
+    {
+        return $this->collection(
+            $role->cachedPermissions(),
+            new PermissionTransformer
+        );
+    }
+}
diff --git a/app/Transformers/SessionTransformer.php b/app/Transformers/SessionTransformer.php
new file mode 100644
index 0000000..fac31af
--- /dev/null
+++ b/app/Transformers/SessionTransformer.php
@@ -0,0 +1,27 @@
+<?php
+
+namespace Portal\Transformers;
+
+use Carbon\Carbon;
+use League\Fractal\TransformerAbstract;
+use Portal\User;
+
+class SessionTransformer extends TransformerAbstract
+{
+    public function transform($session)
+    {
+        $agent = app('agent');
+        $agent->setUserAgent($session->user_agent);
+
+        return [
+            'id' => $session->id,
+            'user_id' => (int) $session->user_id,
+            'ip_address' => $session->ip_address,
+            'user_agent' => $session->user_agent,
+            'browser' => $agent->browser(),
+            'platform' => $agent->platform(),
+            'device' => $agent->device(),
+            'last_activity' => (string) Carbon::createFromTimestamp($session->last_activity)
+        ];
+    }
+}
diff --git a/app/Transformers/UserTransformer.php b/app/Transformers/UserTransformer.php
new file mode 100644
index 0000000..15af0f2
--- /dev/null
+++ b/app/Transformers/UserTransformer.php
@@ -0,0 +1,51 @@
+<?php
+
+namespace Portal\Transformers;
+
+use League\Fractal\TransformerAbstract;
+use Portal\Repositories\Country\CountryRepository;
+use Portal\Repositories\Role\RoleRepository;
+use Portal\User;
+
+class UserTransformer extends TransformerAbstract
+{
+    protected $availableIncludes = ['role', 'country'];
+
+    public function transform(User $user)
+    {
+        return [
+            'id' => $user->id,
+            'first_name' => $user->first_name,
+            'last_name' => $user->last_name,
+            'username' => $user->username,
+            'email' => $user->email,
+            'phone' => $user->phone,
+            'avatar' => $user->present()->avatar,
+            'address' => $user->address,
+            'country_id' => $user->country_id ? (int) $user->country_id : null,
+            'role_id' => (int) $user->role_id,
+            'status' => $user->status,
+            'birthday' => $user->birthday ? $user->birthday->format('Y-m-d') : null,
+            'last_login' => (string) $user->last_login,
+            'two_factor_country_code' => (int) $user->two_factor_country_code,
+            'two_factor_phone' => (string) $user->two_factor_phone,
+            'two_factor_options' => json_decode($user->two_factor_options),
+            'created_at' => (string) $user->created_at,
+            'updated_at' => (string) $user->updated_at
+        ];
+    }
+
+    public function includeRole(User $user)
+    {
+        if (! auth('api')->user()->hasPermission('roles.manage')) {
+            return null;
+        }
+
+        return $this->item($user->role, new RoleTransformer);
+    }
+
+    public function includeCountry(User $user)
+    {
+        return $this->item($user->country, new CountryTransformer);
+    }
+}
diff --git a/app/User.php b/app/User.php
index 317eb0d..e4b5e44 100644
--- a/app/User.php
+++ b/app/User.php
@@ -2,8 +2,12 @@
 
 namespace Portal;
 
+use Carbon\Carbon;
 use Illuminate\Notifications\Notifiable;
+use Tymon\JWTAuth\Contracts\JWTSubject;
 use Portal\Presenters\UserPresenter;
+use Portal\Services\Auth\Api\Token;
+use Portal\Services\Auth\Api\TokenFactory;
 use Portal\Services\Auth\TwoFactor\Authenticatable as TwoFactorAuthenticatable;
 use Portal\Services\Auth\TwoFactor\Contracts\Authenticatable as TwoFactorAuthenticatableContract;
 use Portal\Services\Logging\UserActivity\Activity;
@@ -13,9 +17,13 @@ use Illuminate\Auth\Passwords\CanResetPassword;
 use Laracasts\Presenter\PresentableTrait;
 use Illuminate\Foundation\Auth\User as Authenticatable;
 
-class User extends Authenticatable implements TwoFactorAuthenticatableContract
+class User extends Authenticatable implements TwoFactorAuthenticatableContract, JWTSubject
 {
-    use TwoFactorAuthenticatable, CanResetPassword, PresentableTrait, AuthorizationUserTrait, Notifiable;
+    use TwoFactorAuthenticatable,
+        CanResetPassword,
+        PresentableTrait,
+        AuthorizationUserTrait,
+        Notifiable;
 
     protected $presenter = UserPresenter::class;
 
@@ -34,9 +42,9 @@ class User extends Authenticatable implements TwoFactorAuthenticatableContract
      * @var array
      */
     protected $fillable = [
-        'name', 'email', 'password', 'username', 'first_name', 'last_name', 'phone', 'avatar',
+        'email', 'password', 'username', 'first_name', 'last_name', 'phone', 'avatar',
         'address', 'country_id', 'birthday', 'last_login', 'confirmation_token', 'status',
-        'group_id', 'remember_token', 'role_id'
+        'remember_token', 'role_id'
     ];
 
     /**
@@ -84,11 +92,6 @@ class User extends Authenticatable implements TwoFactorAuthenticatableContract
         return $this->status == UserStatus::BANNED;
     }
 
-    public function socialNetworks()
-    {
-        return $this->hasOne(UserSocialNetworks::class, 'user_id');
-    }
-
     public function country()
     {
         return $this->belongsTo(Country::class, 'country_id');
@@ -98,4 +101,28 @@ class User extends Authenticatable implements TwoFactorAuthenticatableContract
     {
         return $this->hasMany(Activity::class, 'user_id');
     }
+
+    /**
+     * Get the identifier that will be stored in the subject claim of the JWT.
+     *
+     * @return mixed
+     */
+    public function getJWTIdentifier()
+    {
+        return $this->id;
+    }
+
+    /**
+     * Return a key value array, containing any custom claims to be added to the JWT.
+     *
+     * @return array
+     */
+    public function getJWTCustomClaims()
+    {
+        $token = app(TokenFactory::class)->forUser($this);
+
+        return [
+            'jti' => $token->id
+        ];
+    }
 }
diff --git a/config/app.php b/config/app.php
index 651b502..b8b1e5c 100644
--- a/config/app.php
+++ b/config/app.php
@@ -23,7 +23,7 @@ return [
     | Portal Version
     |--------------------------------------------------------------------------
     */
-    'version' => '1.3.3',
+    'version' => '2.0.0',
 
     /*
     |--------------------------------------------------------------------------
@@ -183,10 +183,12 @@ return [
         Webpatser\Countries\CountriesServiceProvider::class,
         Intervention\Image\ImageServiceProvider::class,
         anlutro\LaravelSettings\ServiceProvider::class,
+        Jenssegers\Agent\AgentServiceProvider::class,
 
         /*
          * Application Service Providers...
          */
+        Portal\Services\Auth\Api\JWTServiceProvider::class,
         Portal\Providers\AppServiceProvider::class,
         Portal\Providers\AuthServiceProvider::class,
         // App\Providers\BroadcastServiceProvider::class,
@@ -252,7 +254,8 @@ return [
         'Image' => Intervention\Image\Facades\Image::class,
         'Settings' => anlutro\LaravelSettings\Facade::class,
         'Authy' => Portal\Services\Auth\TwoFactor\Facade::class,
-
+        'JWTAuth' => Tymon\JWTAuth\Facades\JWTAuth::class,
+        'Agent' => Jenssegers\Agent\Facades\Agent::class,
 
     ],
 
diff --git a/config/auth.php b/config/auth.php
index e48dc0a..3ad00a2 100644
--- a/config/auth.php
+++ b/config/auth.php
@@ -2,10 +2,32 @@
 
 return [
 
+    /*
+    |--------------------------------------------------------------------------
+    | Social Authentication Providers
+    |--------------------------------------------------------------------------
+    |
+    | This option controls the list of enabled social authentication providers.
+    |
+    */
+
     'social' => [
         'providers' => ['facebook', 'twitter', 'google']
     ],
 
+   /*
+   |--------------------------------------------------------------------------
+   | JSON API
+   |--------------------------------------------------------------------------
+   |
+   | Should our JSON api be exposed to the public? If you want to enable the
+   | API, just set the following option to "true":
+   |
+   | Default: false
+   */
+
+    'expose_api' => env('EXPOSE_API', false),
+
     /*
     |--------------------------------------------------------------------------
     | Authentication Defaults
@@ -46,7 +68,7 @@ return [
         ],
 
         'api' => [
-            'driver' => 'token',
+            'driver' => 'jwt',
             'provider' => 'users',
         ],
     ],
diff --git a/config/jwt.php b/config/jwt.php
new file mode 100644
index 0000000..d108260
--- /dev/null
+++ b/config/jwt.php
@@ -0,0 +1,262 @@
+<?php
+
+/*
+ * This file is part of jwt-auth.
+ *
+ * (c) Sean Tymon <tymon148@gmail.com>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+return [
+
+    /*
+    |--------------------------------------------------------------------------
+    | JWT Authentication Secret
+    |--------------------------------------------------------------------------
+    |
+    | Don't forget to set this in your .env file, as it will be used to sign
+    | your tokens. A helper command is provided for this:
+    | `php artisan jwt:secret`
+    |
+    | Note: This will be used for Symmetric algorithms only (HMAC),
+    | since RSA and ECDSA use a private/public key combo (See below).
+    |
+    */
+
+    'secret' => env('JWT_SECRET'),
+
+    /*
+    |--------------------------------------------------------------------------
+    | Tokens Sweeping Lottery
+    |--------------------------------------------------------------------------
+    |
+    | Expired api tokens (used as "jti" claim inside JWT tokens) must be
+    | manually removed from storage. Here are the chances that it will
+    | happen whenever new token is generated. By default, the odds are 5 out of 100.
+    |
+    */
+
+    'lottery' => [5, 100],
+
+    /*
+    |--------------------------------------------------------------------------
+    | JWT Authentication Keys
+    |--------------------------------------------------------------------------
+    |
+    | The algorithm you are using, will determine whether your tokens are
+    | signed with a random string (defined in `JWT_SECRET`) or using the
+    | following public & private keys.
+    |
+    | Symmetric Algorithms:
+    | HS256, HS384 & HS512 will use `JWT_SECRET`.
+    |
+    | Asymmetric Algorithms:
+    | RS256, RS384 & RS512 / ES256, ES384 & ES512 will use the keys below.
+    |
+    */
+
+    'keys' => [
+
+        /*
+        |--------------------------------------------------------------------------
+        | Public Key
+        |--------------------------------------------------------------------------
+        |
+        | A path or resource to your public key.
+        |
+        | E.g. 'file://path/to/public/key'
+        |
+        */
+
+        'public' => env('JWT_PUBLIC_KEY'),
+
+        /*
+        |--------------------------------------------------------------------------
+        | Private Key
+        |--------------------------------------------------------------------------
+        |
+        | A path or resource to your private key.
+        |
+        | E.g. 'file://path/to/private/key'
+        |
+        */
+
+        'private' => env('JWT_PRIVATE_KEY'),
+
+        /*
+        |--------------------------------------------------------------------------
+        | Passphrase
+        |--------------------------------------------------------------------------
+        |
+        | The passphrase for your private key. Can be null if none set.
+        |
+        */
+
+        'passphrase' => env('JWT_PASSPHRASE'),
+
+    ],
+
+    /*
+    |--------------------------------------------------------------------------
+    | JWT time to live
+    |--------------------------------------------------------------------------
+    |
+    | Specify the length of time (in minutes) that the token will be valid for.
+    | Defaults to 1 hour.
+    |
+    | You can also set this to null, to yield a never expiring token.
+    | Some people may want this behaviour for e.g. a mobile app.
+    | This is not particularly recommended, so make sure you have appropriate
+    | systems in place to revoke the token if necessary.
+    |
+    */
+
+    'ttl' => env('JWT_TTL', 60),
+
+    /*
+    |--------------------------------------------------------------------------
+    | Refresh time to live
+    |--------------------------------------------------------------------------
+    |
+    | Specify the length of time (in minutes) that the token can be refreshed
+    | within. I.E. The user can refresh their token within a 2 week window of
+    | the original token being created until they must re-authenticate.
+    | Defaults to 2 weeks.
+    |
+    | You can also set this to null, to yield an infinite refresh time.
+    | Some may want this instead of never expiring tokens for e.g. a mobile app.
+    | This is not particularly recommended, so make sure you have appropriate
+    | systems in place to revoke the token if necessary.
+    |
+    */
+
+    'refresh_ttl' => env('JWT_REFRESH_TTL', 20160),
+
+    /*
+    |--------------------------------------------------------------------------
+    | JWT hashing algorithm
+    |--------------------------------------------------------------------------
+    |
+    | Specify the hashing algorithm that will be used to sign the token.
+    |
+    | See here: https://github.com/namshi/jose/tree/master/src/Namshi/JOSE/Signer/OpenSSL
+    | for possible values.
+    |
+    */
+
+    'algo' => env('JWT_ALGO', 'HS256'),
+
+    /*
+    |--------------------------------------------------------------------------
+    | Required Claims
+    |--------------------------------------------------------------------------
+    |
+    | Specify the required claims that must exist in any token.
+    | A TokenInvalidException will be thrown if any of these claims are not
+    | present in the payload.
+    |
+    */
+
+    'required_claims' => [
+        'iss',
+        'iat',
+        'exp',
+        'nbf',
+        'sub',
+        'jti',
+    ],
+
+    /*
+    |--------------------------------------------------------------------------
+    | Persistent Claims
+    |--------------------------------------------------------------------------
+    |
+    | Specify the claim keys to be persisted when refreshing a token.
+    | `sub` and `iat` will automatically be persisted, in
+    | addition to the these claims.
+    |
+    | Note: If a claim does not exist then it will be ignored.
+    |
+    */
+
+    'persistent_claims' => [
+        // 'foo',
+        // 'bar',
+    ],
+
+    /*
+    |--------------------------------------------------------------------------
+    | Blacklist Enabled
+    |--------------------------------------------------------------------------
+    |
+    | In order to invalidate tokens, you must have the blacklist enabled.
+    | If you do not want or need this functionality, then set this to false.
+    |
+    */
+
+    'blacklist_enabled' => env('JWT_BLACKLIST_ENABLED', true),
+
+    /*
+    | -------------------------------------------------------------------------
+    | Blacklist Grace Period
+    | -------------------------------------------------------------------------
+    |
+    | When multiple concurrent requests are made with the same JWT,
+    | it is possible that some of them fail, due to token regeneration
+    | on every request.
+    |
+    | Set grace period in seconds to prevent parallel request failure.
+    |
+    */
+
+    'blacklist_grace_period' => env('JWT_BLACKLIST_GRACE_PERIOD', 0),
+
+    /*
+    |--------------------------------------------------------------------------
+    | Providers
+    |--------------------------------------------------------------------------
+    |
+    | Specify the various providers used throughout the package.
+    |
+    */
+
+    'providers' => [
+
+        /*
+        |--------------------------------------------------------------------------
+        | JWT Provider
+        |--------------------------------------------------------------------------
+        |
+        | Specify the provider that is used to create and decode the tokens.
+        |
+        */
+
+        'jwt' => Tymon\JWTAuth\Providers\JWT\Namshi::class,
+
+        /*
+        |--------------------------------------------------------------------------
+        | Authentication Provider
+        |--------------------------------------------------------------------------
+        |
+        | Specify the provider that is used to authenticate users.
+        |
+        */
+
+        'auth' => Tymon\JWTAuth\Providers\Auth\Illuminate::class,
+
+        /*
+        |--------------------------------------------------------------------------
+        | Storage Provider
+        |--------------------------------------------------------------------------
+        |
+        | Specify the provider that is used to store tokens in the blacklist.
+        |
+        */
+
+        'storage' => Tymon\JWTAuth\Providers\Storage\Illuminate::class,
+
+    ],
+
+];
diff --git a/database/factories/ModelFactory.php b/database/factories/ModelFactory.php
index 53b8aca..cb6c8aa 100644
--- a/database/factories/ModelFactory.php
+++ b/database/factories/ModelFactory.php
@@ -82,3 +82,17 @@ $factory->define(Country::class, function (Faker\Generator $faker) {
         'sub_region_code' => 123
     ];
 });
+
+$factory->define(\Portal\Services\Auth\Api\Token::class, function (Faker\Generator $faker, array $attrs) {
+    $userId = isset($attrs['user_id'])
+        ? $attrs['user_id']
+        : factory(\Portal\User::class)->create()->id;
+
+    return [
+        'id' => str_random(40),
+        'user_id' => $userId,
+        'ip_address' => $faker->ipv4,
+        'user_agent' => substr($faker->userAgent, 0, 500),
+        'expires_at' => \Carbon\Carbon::now()->addMinutes(60)
+    ];
+});
diff --git a/database/migrations/2015_10_10_170827_create_users_table.php b/database/migrations/2015_10_10_170827_create_users_table.php
index a891803..b41dcc5 100644
--- a/database/migrations/2015_10_10_170827_create_users_table.php
+++ b/database/migrations/2015_10_10_170827_create_users_table.php
@@ -15,7 +15,7 @@ class CreateUsersTable extends Migration
         Schema::create('users', function (Blueprint $table) {
             $table->increments('id');
             $table->string('email')->unique();
-            $table->string('username')->nullable();
+            $table->string('username')->nullable()->index();
             $table->string('password');
             $table->string('first_name')->nullable();
             $table->string('last_name')->nullable();
@@ -27,7 +27,7 @@ class CreateUsersTable extends Migration
             $table->date('birthday')->nullable();
             $table->timestamp('last_login')->nullable();
             $table->string('confirmation_token', 60)->nullable();
-            $table->string('status', 20);
+            $table->string('status', 20)->index();
             $table->integer('two_factor_country_code')->nullable();
             $table->integer('two_factor_phone')->nullable();
             $table->text('two_factor_options')->nullable();
diff --git a/database/migrations/2015_12_30_171734_add_foreign_keys.php b/database/migrations/2015_12_30_171734_add_foreign_keys.php
index f537c2d..e1633eb 100644
--- a/database/migrations/2015_12_30_171734_add_foreign_keys.php
+++ b/database/migrations/2015_12_30_171734_add_foreign_keys.php
@@ -29,13 +29,6 @@ class AddForeignKeys extends Migration
                 ->on('users')
                 ->onDelete('cascade');
         });
-
-        Schema::table('user_social_networks', function (Blueprint $table) {
-            $table->foreign('user_id')
-                ->references('id')
-                ->on('users')
-                ->onDelete('cascade');
-        });
     }
 
     /**
@@ -53,9 +46,5 @@ class AddForeignKeys extends Migration
         Schema::table('social_logins', function (Blueprint $table) {
             $table->dropForeign('social_logins_user_id_foreign');
         });
-
-        Schema::table('user_social_networks', function (Blueprint $table) {
-            $table->dropForeign('user_social_networks_user_id_foreign');
-        });
     }
 }
diff --git a/database/migrations/2017_04_13_200254_create_api_tokens_table.php b/database/migrations/2017_04_13_200254_create_api_tokens_table.php
new file mode 100644
index 0000000..4529f98
--- /dev/null
+++ b/database/migrations/2017_04_13_200254_create_api_tokens_table.php
@@ -0,0 +1,49 @@
+<?php
+
+use Illuminate\Support\Facades\Schema;
+use Illuminate\Database\Schema\Blueprint;
+use Illuminate\Database\Migrations\Migration;
+
+class CreateApiTokensTable extends Migration
+{
+    /**
+     * Run the migrations.
+     *
+     * @return void
+     */
+    public function up()
+    {
+        Schema::create('api_tokens', function (Blueprint $table) {
+            $table->string('id', 40);
+            $table->unsignedInteger('user_id');
+            $table->string('ip_address', 45)->nullable();
+            $table->text('user_agent')->nullable();
+            $table->timestamps();
+            $table->timestamp('expires_at')->nullable();
+
+            $table->primary('id');
+            $table->index(['id', 'expires_at']);
+        });
+
+        Schema::table('api_tokens', function (Blueprint $table) {
+            $table->foreign('user_id')
+                ->references('id')
+                ->on('users')
+                ->onDelete('cascade');
+        });
+    }
+
+    /**
+     * Reverse the migrations.
+     *
+     * @return void
+     */
+    public function down()
+    {
+        Schema::table('api_tokens', function (Blueprint $table) {
+            $table->dropForeign('api_tokens_user_id_foreign');
+        });
+
+        Schema::dropIfExists('api_tokens');
+    }
+}
